/*
 * File:    main.c
 * Author:  F.Giamarchi
 * Board:   Picky_4.2
 *
 * Created on 28 oct. 2017, 00:00
 * Revised on 16 aout 2018, 00:00
 * Revised on 21 fev. 2018, 00:00
 */

#include <xc.h>         // XC8 compilateur
#include <stdint.h>     // uint8_t dfinitions
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "system.h"     // fichier des actions d'initialisation du C
#include "user.h"
#include "interruptions.h"
#include "moteurs.h"

uint8_t variable_8bits;     // exemple de dclaration d'une variable 8 bits non signe
uint16_t variable_16bits;   // exemple de dclaration d'une variable 16 bits non signe
char carac;                 // exemple de dclaration d'une variable caractre
char table[5];              // exemple de dclaration d'une table de 5 valeurs

uint8_t etat;
uint16_t compteur, tempo;
uint16_t mes_bat;
char command[7];
char cmd, param[4];
uint8_t data, action;
int8_t vit_g, vit_d;

uint16_t tick_UART = 1000;   // priode pour les printf 
uint8_t tick_DB = 200;      // 200ms priode pour 

void main(void)
{
/*  On initialise le microcontroleur */
    Init_System();
    Init_Interruptions();
        
    etat = 0;
    compteur = 0;
    
/*  Cration d'une boucle infinie indispensable !!! */
    while (1)
    {
        Synchronisation();      // Force la boucle infinie  s'xcuter 
        compteur++;             // toutes les 1ms

/*  Gestion d'un menu de test du matriel */
        switch (etat)
        {
            case 0:             // Test Del et Bouton Poussoir
                Code_Del(1);
                // Mesure de la tension de la batterie en mV
                
                // Affiche la tension batterie toutes les 500ms
                
                if (Appui_BP())
                {
                    etat = 1;
                }
                break;
            case 1:                     // Temporisation de 2 sec avant dpart du robot
                Code_Del(3);

                break;
            case 2:                     // Test des moteurs pendant 1 sec puis retour  l'tat 0
                Code_Del(1);
                
                vit_g = 50;
                vit_d = 50;
                Moteurs(vit_g,vit_d);
                
                break;
            default:
                etat = 0;
                break;
        }
        
// Si rception d'une commande PC -> Pilote le robot par Bluetooth
        if(Data_Rdy_UART())
        {
            Read_Data_UART(command);
            printf("%s\r\n",command);       // Echo
            /*  Lecture de la commande */
            if(command[0] == '$')
            {
                cmd = command[1];
                uint8_t i = 0;
                do
                {
                    param[i] = command[i+2];
                    i++;
                }
                while(command[i] != '\0');
                data = atoi(param);
            }
        }
    }
}
