/******************************************************************************/
/* Files to Include                                                           */
/******************************************************************************/
#include <xc.h>         /* XC8 General Include File */
#include <stdint.h>         /* For uint8_t definition */
#include <stdbool.h>        /* For true/false definition */

#include "I2Cmaster.h"
#include "mcp23008.h"

void MCP23008_Init (void)
{
    I2C_Start(I2C_START_CMD);
    I2C_Write(MCP23008_ADR_W);        // Adresse MCP23008
    I2C_Write(_IODIR);
//    I2C_Write(0xFF);           // Toutes les lignes en entre
//    I2C_Write(0x00);           // Toutes les lignes en sortie
    I2C_Write(0xFE);           // _GPIO -> bit 0 en sortie, le reste en entre
    I2C_Write(0x00);            // _IPOL
    I2C_Write(0x00);            // _GPINTEN
    I2C_Write(0x00);            // _DEFVAL
    I2C_Write(0x00);            // _INTCON
    I2C_Write(0x00);            // _IOCON
    I2C_Write(0x80);            // _GPPU -> Resistance de pullup sur bit 7
    I2C_Stop();
}

void MCP23008_Write (uint8_t _data)
{
    I2C_Start(I2C_START_CMD);
    I2C_Write(MCP23008_ADR_W);        // Adresse MCP23008
    I2C_Write(_OLAT);
    I2C_Write(_data);
    I2C_Stop();
}

uint8_t MCP23008_Read (void)
{
    uint8_t _data = 0;
    I2C_Start(I2C_START_CMD);
    I2C_Write(MCP23008_ADR_W);        // Adresse MCP23008
    I2C_Write(_GPIO);
    I2C_Start(I2C_REP_START_CMD);
    I2C_Write(MCP23008_ADR_R);        // Adresse MCP23008
    _data = I2C_Read();
    I2C_Stop();
    return _data;
}