/* 
 * File:   system.h
 * Author: F.Giamarchi
 *
 * Created on 3 janvier 2017, 00:00
 */

#ifndef SYSTEM_H
#define	SYSTEM_H

/* Frquence de l'oscillateur */
#define _XTAL_FREQ 32000000 // Cette ligne permet d'utiliser les temporisations

// Ces lignes permettent de donner des noms explicites  des lignes du C et  des regsitres
//  TODO 1 -> Donner des noms explicites aux lignes utilises
#define DEL LATA6
#define DIR_DEL TRISA6

#define MOT_GA_1 LATB3
#define DIR_MOT_GA_1 TRISB3
#define MOT_GA_2 LATB6
#define DIR_MOT_GA_2 TRISB6
#define MOT_DR_1 LATA3
#define DIR_MOT_DR_1 TRISA3
#define MOT_DR_2 LATA4
#define DIR_MOT_DR_2 TRISA4

#define BP PORTAbits.RA7
#define DIR_BP TRISA7

/*  Dclaration de la fonction d'initialisation du microcontroleur */
void Init_System(void);

/*  Fonction temporisation en msec. */
void delayMs(uint16_t ms);

/*  Dclarations pratiques */
#define DEL_ON RA6=1
#define DEL_OFF RA6=0



/* Dclaration des fonctions associes au Convertisseur Analog Digital */
void Init_ADC(void);
void SelChanADC(uint8_t canal);
uint8_t Read_Adc_8bits(void);
//uint16_t Read_Adc_10bits(void);

/* Dclaration des fonctions de gestion du Timer0 */
void Init_Timer0(void);
void Synchronisation(void);
/* Dclaration des fonctions de gestion du Timer1 */
void Init_Timer1(void);

/*  Dclarations des macros pour le Timer0 */
#define TMR0_PRE 0b100          // Prescaleur sur 1/16
#define TMR0_VALUE 0xFF-249     // 250 * 32 * 125ns = 1ms

/*  Dclarations des macros pour le Timer1 */
#define TMR1_PRE 0b11;          // Division par 8 --> compte les s
#define TMR1_VALUE 0xFFFF-17000     // 17000 * 8 * 125ns = 17ms

/*  Dclaration des fonctions associes  l'UART */
void Init_UART(void);
void putch(char c);
//char getch(void);

/*  Dclarations des fonctions associes au Timer2 */
void Init_Timer2(void);

#endif	/* SYSTEM_H */

