#include <xc.h>         // XC8 compilateur
#include <stdint.h>
#include <stdio.h>     // uint8_t dfinitions
#include <stdlib.h>

#include "system.h"
#include "user.h"

/**
 * Fonction de contrle de la DEL
 * @file user.c
 * @param nb_cli
 * : nombre de clignotement par seconde
 */
void Code_Del(uint8_t nb_cli)
{
static uint16_t cmpt_del, mem_cmpt;
static uint8_t etat, mem_cli;
    
    cmpt_del++;
    
    switch (etat)
    {
        case 0:
            DEL = 0;
            if(cmpt_del >= 1000)
            {
                cmpt_del = 0;
                mem_cli = nb_cli;
                etat++;
                mem_cmpt = 10;
            }
            break;
        case 1:
            DEL = 1;
            if(cmpt_del == mem_cmpt)
            {
                mem_cli--;
                if(mem_cli == 0)
                    etat = 0;
                else
                {
                    mem_cmpt = cmpt_del + 320;
                    etat++;
                }
            }
            break;
        case 2:
            DEL = 0;
            if(cmpt_del == mem_cmpt)
            {
                mem_cmpt = cmpt_del + 10;
                etat = 1;
            }
            break;
        default:
            etat = 0;
            break;
    }
}

uint8_t etat_BP, etat_BP_old, compt_BP;
/**
 * Dfinition d'une fonction de gestion du Bouton Poussoir
 * @file user.c
 * @return
 * 0 -> appui   1 -> relach
 */
uint8_t Appui_BP(void)
{
uint8_t resultat_appui = 0;
    
    if(compt_BP++ > 50)
    {
        compt_BP = 0;
        etat_BP = BP;
        if(etat_BP_old && !etat_BP)
            resultat_appui = 1;
        else
            resultat_appui = 0;
        etat_BP_old = etat_BP;
    }
    return resultat_appui;
}

/**
 * Fonction de mesure de la tension sur la batterie
 * @file user.c
 * @return
 * valeur sur 8bits
 */
uint8_t Mesure_Batterie(void)
{
static uint8_t _mes_bat;  
//static uint16_t cmpt_bat = 1000;
//uint16_t bat_ent, bat_frac;
    /*  pont diviseur par 1/2 et quantum = 19.6mV */
    SelChanADC(6);
    __delay_us(10);
    _mes_bat = Read_Adc_8bits();     // Pour 9Volts => 225


////        bat_ent = (mes_bat<<2)/100;
////        bat_frac = (mes_bat<<2) - (bat_ent*100);
////        printf("Bat : %d,%d V\r\n",bat_ent,bat_frac/10);

    return _mes_bat;
}

uint8_t capt_ga, capt_ce, capt_dr;
uint16_t capt_cmpt, capt_tempo;
void Lecture_Entrees(void)
{
//    SelChanADC(0);
    capt_ga = Read_Adc_8bits();
//    SelChanADC(1);
//    capt_ce = Read_Adc_8bits();
//    SelChanADC(2);
//    capt_dr = Read_Adc_8bits();
    
    if (!capt_cmpt--)
    {
        capt_cmpt = 500;
//        printf("%d\t%d\t%d\r\n",capt_ga,capt_ce,capt_dr);
        printf("%d\r\n",capt_ga);
    }
}




